<?php
/**
 *
 * Copyright notice
 *
 * (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 */

return call_user_func(
	function ($extKey, $table) {
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes(
					'tx_sgjobs_domain_model_job',
					''
				);
		$columns = [
			'ctrl' => [
				'title' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '',
				'label' => 'title',
				'tstamp' => 'tstamp',
				'crdate' => 'crdate',
				'cruser_id' => 'cruser_id',
				'dividers2tabs' => TRUE,
				'searchFields' => 'title, job_id, path_segment, start_date, alternative_start_date, company, contact, department, experience_level',
				'versioningWS' => 2,
				'versioning_followPages' => TRUE,
				'origUid' => 't3_origuid',
				'languageField' => 'sys_language_uid',
				'transOrigPointerField' => 'l10n_parent',
				'transOrigDiffSourceField' => 'l10n_diffsource',
				'delete' => 'deleted',
				'enablecolumns' => [
					'disabled' => 'hidden',
					'starttime' => 'starttime',
					'endtime' => 'endtime',
				],
				'sortby' => 'sorting',
				'iconfile' => 'EXT:' . $extKey . '/Resources/Public/Icons/' . $table . '.svg'
			],
			'interface' => [],
			'types' => [
				'1' => [
					'showitem' => '--palette--;;sysLanguageAndHidden, --palette--;;palette_title,
						--palette--;;palette_title_start,
						--palette--;;palette_apply_function,
						department,
						experience_level,
						company,
						contact,
						description,
						attachment,
						--div--; LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:tca.qualification_tab, task, qualification,
						--div--; LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:tca.seo_tab,
							--palette--;;palette_location_specifications,
							employment_types,
							--palette--;;palette_seo_dates,
							--palette--;;palette_salary,
						--div--;LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:tabs.access, starttime, endtime,
						--div--;LLL:EXT:languagevisibility/Resources/Private/Language/locallang_db.xml:tabname, tx_languagevisibility_visibility',
				],
			],
			'palettes' => [
				'sysLanguageAndHidden' => [
					'showitem' => 'sys_language_uid;;;;1-1-1, l10n_diffsource, hidden;;1, ',
					'canNotCollapse' => 1,
				],
				'palette_title' => ['showitem' => 'title, path_segment, job_id', 'canNotCollapse' => 1],
				'palette_title_start' => ['showitem' => 'start_date, alternative_start_date', 'canNotCollapse' => 1],
				'palette_apply_function' => ['showitem' => 'hide_apply_by_email, hide_apply_by_postal, featured_offer', 'canNotCollapse' => 1],
				'palette_location_specifications' => ['showitem' => 'telecommute_possible, office_work_possible'],
				'palette_seo_dates' => ['showitem' => 'date_posted, valid_through'],
				'palette_salary' => [
					'label' =>  'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:tca.salary_palette',
					'showitem' => 'salary_currency, --linebreak--, base_salary, max_salary, --linebreak--, salary_unit,'
				]
			],
			'columns' => [
				'sorting' => [
					'config' => [
						'type' => 'passthrough'
					]
				],
				'crdate' => [
					'exclude' => FALSE,
					'config' => [
						'type' => 'passthrough'
					]
				],
				'sys_language_uid' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.language',
					'config' => [
						'type' => 'select',
						'special' => 'languages',
					],
				],
				'l10n_parent' => [
					'displayCond' => 'FIELD:sys_language_uid:>:0',
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.l18n_parent',
					'config' => [
						'type' => 'select',
						'items' => [
							['', 0],
						],
						'foreign_table' => $table,
						'foreign_table_where' => 'AND ' . $table . '.pid=###CURRENT_PID### AND ' . $table . '.sys_language_uid IN (-1,0)',
					],
				],
				'l10n_diffsource' => [
					'config' => [
						'type' => 'passthrough',
					],
				],
				'tx_languagevisibility_visibility' => [
					'exclude' => 1,
					'label' => 'LLL:EXT:languagevisibility/locallang_db.xlf:pages.tx_languagevisibility_visibility',
					'config' => [
						'type' => 'user',
						'size' => '30',
						'userFunc' => 'TYPO3\Languagevisibility\UserFunction\FieldVisibilityUserFunction->user_fieldvisibility',
					]
				],
				't3ver_label' => [
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.versionLabel',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'max' => 255,
					]
				],
				'pid' => [
					'exclude' => FALSE,
					'label' => 'PID',
					'config' => [
						'type' => 'none',
					]
				],
				'hidden' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.hidden',
					'config' => [
						'type' => 'check',
					],
				],
				'starttime' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.starttime',
					'config' => [
						'type' => 'input',
						'renderType' => 'inputDateTime',
						'eval' => 'datetime,int',
						'default' => 0
					],
					'l10n_mode' => 'exclude',
					'l10n_display' => 'defaultAsReadonly'
				],
				'endtime' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.endtime',
					'config' => [
						'type' => 'input',
						'renderType' => 'inputDateTime',
						'eval' => 'datetime,int',
						'default' => 0,
						'range' => [
							'upper' => mktime(0, 0, 0, 1, 1, 2038)
						]
					],
					'l10n_mode' => 'exclude',
					'l10n_display' => 'defaultAsReadonly'
				],
				'path_segment' => [
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.path_segment',
					'config' => [
						'type' => 'slug',
						'generatorOptions' => [
							'fields' => ['title'],
							'fieldSeparator' => '/',
							'prefixParentPageSlug' => FALSE,
							'replacements' => [
								'/' => '-',
							],
						],
						'fallbackCharacter' => '-',
						'eval' => 'uniqueInPid'
					]
				],
				'title' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.title',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim, required'
					],
				],
				'job_id' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.jobId',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'attachment' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.attachment',
					'config' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig(
						'attachment',
						['maxitems' => 1],
						'pdf'
					)
				],
				'department' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.department',
					'config' => [
						'type' => 'select',
						'renderType' => 'selectMultipleSideBySide',
						'foreign_table' => 'tx_sgjobs_domain_model_department',
						'foreign_table_where' => ' AND tx_sgjobs_domain_model_department.sys_language_uid IN (0,-1) ORDER BY tx_sgjobs_domain_model_department.sorting ASC',
						'minitems' => 1,
						'maxitems' => 1,
						'size' => 5,
						'fieldControl' => [
							'editPopup' => [
								'disabled' => FALSE,
							],
							'addRecord' => [
								'disabled' => FALSE,
							]
						]
					],
				],
				'experience_level' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.experience_level',
					'config' => [
						'type' => 'select',
						'renderType' => 'selectMultipleSideBySide',
						'foreign_table' => 'tx_sgjobs_domain_model_experience_level',
						'foreign_table_where' => ' AND tx_sgjobs_domain_model_experience_level.sys_language_uid IN (0,-1) ORDER BY tx_sgjobs_domain_model_experience_level.sorting ASC',
						'minitems' => 0,
						'maxitems' => 1,
						'size' => 5,
						'fieldControl' => [
							'editPopup' => [
								'disabled' => FALSE,
							],
							'addRecord' => [
								'disabled' => FALSE,
							]
						]
					],
				],
				'featured_offer' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.featuredOffer',
					'config' => [
						'type' => 'check',
					],
				],
				'hide_apply_by_email' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.hideApplyByEmail',
					'config' => [
						'type' => 'check',
					],
				],
				'hide_apply_by_postal' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.hideApplyByPostal',
					'config' => [
						'type' => 'check',
					],
				],
				'start_date' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.start_date',
					'config' => [
						'type' => 'input',
						'renderType' => 'inputDateTime',
						'size' => 13,
						'max' => 20,
						'eval' => 'date'
					],
				],
				'alternative_start_date' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.alternative_start_date',
					'config' => [
						'type' => 'input',
						'size' => 30,
						'eval' => 'trim'
					],
				],
				'task' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.task',
					'config' => [
						'type' => 'text',
						'cols' => 40,
						'rows' => 10,
						'eval' => ''
					],
					'defaultExtras' => 'richtext[]'
				],
				'qualification' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.qualification',
					'config' => [
						'type' => 'text',
						'cols' => 40,
						'rows' => 10,
						'eval' => ''
					],
					'defaultExtras' => 'richtext[]'
				],
				'description' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.description',
					'config' => [
						'type' => 'text',
						'cols' => 40,
						'rows' => 10,
						'eval' => ''
					],
					'defaultExtras' => 'richtext[]'
				],
				'company' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.company',
					'config' => [
						'type' => 'select',
						'renderType' => 'selectMultipleSideBySide',
						'foreign_table' => 'tx_sgjobs_domain_model_company',
						'foreign_table_where' => ' AND tx_sgjobs_domain_model_company.sys_language_uid IN (0,-1) ORDER BY tx_sgjobs_domain_model_company.sorting ASC',
						'size' => 5,
						'minitems' => 1,
						'maxitems' => 1,
						'multiple' => 0,
						'fieldControl' => [
							'editPopup' => [
								'disabled' => FALSE,
							],
							'addRecord' => [
								'disabled' => FALSE,
							]
						],
					]
				],
				'contact' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.contact',
					'config' => [
						'type' => 'select',
						'renderType' => 'selectMultipleSideBySide',
						'foreign_table' => 'tx_sgjobs_domain_model_contact',
						'foreign_table_where' => ' AND tx_sgjobs_domain_model_contact.sys_language_uid IN (0,-1) ORDER BY tx_sgjobs_domain_model_contact.sorting ASC',
						'size' => 5,
						'minitems' => 1,
						'maxitems' => 1,
						'multiple' => 0,
						'fieldControl' => [
							'editPopup' => [
								'disabled' => FALSE,
							],
							'addRecord' => [
								'disabled' => FALSE,
							]
						],
					]
				],
				'telecommute_possible' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.telecommutePossible',
					'config' => [
						'type' => 'check',
					],
				],
				'office_work_possible' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.officeWorkPossible',
					'config' => [
						'type' => 'check',
					],
				],
				'employment_types' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types',
					'config' => [
						'type' => 'select',
						'renderType' => 'selectMultipleSideBySide',
						'items' => [
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types.full_time', 'FULL_TIME'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types.part_time', 'PART_TIME'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types.contractor', 'CONTRACTOR'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types.temporary', 'TEMPORARY'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types.intern', 'INTERN'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types.volunteer', 'VOLUNTEER'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types.per_diem', 'PER_DIEM'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.employment_types.other', 'OTHER']
						]
					]
				],
				'date_posted' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.date_posted',
					'config' => [
						'type' => 'input',
						'renderType' => 'inputDateTime',
						'eval' => 'date'
					],
				],
				'valid_through' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.valid_through',
					'config' => [
						'type' => 'input',
						'renderType' => 'inputDateTime',
						'eval' => 'date'
					],
				],
				'salary_currency' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.salary_currency',
					'config' => [
						'type' => 'input',
						'eval' => 'alpha, upper',
						'max' => 3,
						'default' => 'EUR',
					],
				],
				'salary_unit' => [
					'exclude' => TRUE,
					'l10n_mode' => 'exclude',
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.salary_unit',
					'config' => [
						'type' => 'select',
						'renderType' => 'selectSingle',
						'items' => [
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.salary_unit.hour', 'HOUR'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.salary_unit.day', 'DAY'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.salary_unit.week', 'WEEK'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.salary_unit.month', 'MONTH'],
							['LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.salary_unit.year', 'YEAR'],
						]
					]
				],
				'base_salary' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.base_salary',
					'config' => [
						'type' => 'input',
						'eval' => 'double2',
						'max' => 15,
					],
				],
				'max_salary' => [
					'exclude' => TRUE,
					'label' => 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:' . $table . '.max_salary',
					'config' => [
						'type' => 'input',
						'eval' => 'double2',
						'max' => 15,
					],
				],
			],
		];
		if (version_compare(\TYPO3\CMS\Core\Utility\VersionNumberUtility::getCurrentTypo3Version(), '10.3.0', '<')) {
			$columns['interface']['showRecordFieldList'] = 'sys_language_uid, l10n_parent, l10n_diffsource, hidden, pid, title, path_segment, job_id, department, experience_level, hide_apply_by_email, hide_apply_by_postal, featured_offer, start_date, alternative_start_date,company, task, qualification, description, contact, telecommute, employment_types, date_posted, valid_through, salary_currency, base_salary, max_salary, salary_unit';
		}

		return $columns;
	}, 'sg_jobs', 'tx_sgjobs_domain_model_job'
);

